﻿using System;
using System.ComponentModel.Composition;

namespace LearningMEF.PluginLoader.Plugins
{
    [Export(typeof(IPlugin))]
    [PluginMetadata("Default", "1.0.0.0")]
    public class DefaultPlugin : IPlugin
    {
        public string PluginAction()
        {
            return "This is the default Plugin";
        }
    }
    
    public interface IPluginMetadata
    {
        string Name { get; }
        string Version { get; }
    }

    [MetadataAttribute]
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false)]
    public class PluginMetadataAttribute : ExportAttribute
    {
        public PluginMetadataAttribute( string name, string version )
            : base(typeof(IPluginMetadata))
        {
            Name = name;
            Version = version;
        }

        public string Name { get; set; }
        public string Version { get; set; }
    }
}