﻿using System;
using System.ComponentModel.Composition;
using System.Diagnostics;

namespace LearningMEF.ConsoleLogger
{
    public class ConsoleLogger
    {
        [Export( "Logger.LogDebug", typeof( Action<string> ) )]
        public void LogDebug( string something )
        {
            Debug.WriteLine( string.Format( "Console Logger (debug): {0}", something ) );
        }

        [Export( "Logger.LogMessage", typeof( Action<string> ) )]
        public void LogMessage( string something )
        {
            Debug.WriteLine( string.Format( "Console Logger (msg): {0}", something ) );
        }

        [Export( typeof( Action<string, Exception> ) )]
        public void LogError( string something, Exception exception )
        {
            Debug.WriteLine( string.Format( "Console Logger (exception): {0} threw the error of {1}", something, exception ) );
        }

        [Export(typeof(string))]
        public string NameOfLogger { get { return "Console"; } }
    }
}
