﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace LearningMEF.PluginLoader.Plugins
{
    [Export( typeof (Logger) )]
    public class Logger
    {
        [Import( "Logger.LogDebug", typeof (Action<string>), AllowRecomposition = true )]
        public Action<string> LogDebug { get; set; }

        [Import( "Logger.LogMessage", typeof (Action<string>), AllowRecomposition = true )]
        public Action<string> LogMessage { get; set; }

        [Import( typeof (Action<string, Exception>), AllowRecomposition = true )]
        public Action<string, Exception> LogException { get; set; }

        private string _name = "Default";

        [Import( typeof (string) )]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
    }

    public class DefaultLogger : Logger
    {
        public DefaultLogger()
        {
            base.LogDebug = this.LogAsDebug;
            base.LogMessage = LogAaMessage;
            base.LogException = this.LogAsException;
        }

        public void LogAsDebug( string something )
        {
            Debug.WriteLine( string.Format( "Default Logger (debug): {0}", something ) );
        }

        public void LogAaMessage( string something )
        {
            Debug.WriteLine( string.Format( "Default Logger (msg): {0}", something ) );
        }

        public void LogAsException( string something, Exception exception )
        {
            Debug.WriteLine( string.Format( "Default Logger (exception): {0} threw the error of {1}", something, exception ) );
        }

    }
}
